<?php
class db
{
    protected $database;
    public function __construct()
    {
        $this->database = new SQLite3('db_zeeslag.db');
    }


    public function checkLogin($usrName, $password)
    {
        $stmt = $this->database->prepare("SELECT * FROM users WHERE usr_name=:usrName AND password=:pass");
        $stmt->bindValue('usrName', $usrName, SQLITE3_TEXT);
        $stmt->bindValue('pass', $password, SQLITE3_TEXT);
        $res = $stmt->execute();
        $_SESSION['err_mess_db'] = $this->database->lastErrorCode() . ":" .  $this->database->lastErrorMsg();

        if ($row = $res->fetchArray(SQLITE3_ASSOC)) {
            return ['usr_id' => $row['usr_id'], 'usr_name' => $row['usr_name']];
        } else {
            return false;
        }
    }

    public function registerUser($usrName, $password)
    {

        if (!$this->checkLogin($usrName, $password)) {
            unset($_SESSION['mess']);
            $stmt = $this->database->prepare("INSERT INTO users (usr_name, password) VALUES (:usrName, :pass)");
            $stmt->bindValue('usrName', $usrName, SQLITE3_TEXT);
            $stmt->bindValue('pass', $password, SQLITE3_TEXT);
            $stmt->execute();
            $_SESSION['err_mess_db'] = $this->database->lastErrorCode() . ": " .  $this->database->lastErrorMsg();
            return true;
        } else {
            return false;
        }
    }

    public function writeScore($usr_id, $diff, $won, $shotsLeft)
    {

        $date = new DateTime(date('d-m-Y H:i:s'), new DateTimeZone('UTC'));
        $stmt = $this->database->prepare("INSERT INTO games (usr_id, date, difficulty, won, shots_left) VALUES(:usrId, :date, :difficulty, :won, :shotsLeft)");
        $stmt->bindValue('usrId', $usr_id, SQLITE3_TEXT);
        $stmt->bindValue('date', $date->format('d-m-Y H:i:s'), SQLITE3_TEXT);
        $stmt->bindValue('difficulty', $diff, SQLITE3_TEXT);
        $stmt->bindValue('won', $won, SQLITE3_TEXT);
        $stmt->bindValue('shotsLeft', $shotsLeft, SQLITE3_TEXT);
        $stmt->execute();
    }
    public function printScore($usr_id)
    {
        $stmt = $this->database->prepare("SELECT * FROM games WHERE usr_id=:usrId ORDER BY date desc");
        $stmt->bindValue('usrId', $usr_id, SQLITE3_TEXT);
        $res =  $stmt->execute();
        return $res;
    }

    public function spoofDbTemporarily()
    {
        $stmt = $this->database->prepare("SELECT * FROM users");
        $res = $stmt->execute();

        return $res;
    }
}
$db = new db;