<?php
require_once "dbase.inc";

function checkLogin($usrName, $password)
{
    unset($_SESSION['mess']);
    global $db;
    $login = $db->checkLogin($usrName, $password);

    if ($login) {
        $_SESSION['usr_id'] = $login['usr_id'];
        $_SESSION['usr_name'] = $login['usr_name'];
        $_SESSION['cur_session_time'] = time();
        unset($_SESSION['err_mess']);
    } else {
        unset($_SESSION['usr_id']);
        unset($_SESSION['usr_name']);
        unset($_SESSION['mess']);
        // printMessage('Login failed, username or password not correct, try again', 'alert');
        $_SESSION['err_mess'] = "<span class='alert'>Login failed, username or password not correct, try again</span>";
    }
    return;
}

function registerUser($usrName, $password, $cPassword)
{
    global $db;
    if ($password === $cPassword) {
        unset($_SESSION['err_mess']);
        $register = $db->registerUser($usrName, $password);

        if ($register) {
            printMessage("Signed up succesfully", "success");
            // $_SESSION['mess'] = "<span class='success'>Signed up succesfully</span>";
            header('location: index.php');
        } else {
            printMessage("Username already exists", "alert");
            // $_SESSION['err_mess'] = "<span class='alert'>Username already exists</span>";
        }
    } else {
        printMessage("Passwords do not match!", "alert");
        // $_SESSION['mess'] = "<span class='alert'>Passwords do not match!</span>";
    }
}

function writeScore($usr_id, $diff, $won, $shotsLeft)
{
    global $db;

    $db->writeScore($usr_id, $diff, $won, $shotsLeft);
}

// Deze funtie is zichtbaar in de scores tab
function printScores($usr_id)
{
    global $db;
    $scores = $db->printScore($usr_id);
    $html = "";
    while ($row = $scores->fetchArray(SQLITE3_ASSOC)) {
        $html .= "<tr><td>" .  $row['date'] . "</td><td>" . $_SESSION['statusLabel'][$row['won']] . "</td><td>" . $row['shots_left'] . "</td><td>" . $_SESSION['diffLabel'][$row['difficulty'] - 1] . "</td></tr>";
    }
    if (empty($scores->fetchArray(SQLITE3_ASSOC))) {
        $html = "<tr><td rowspan='4'>No games played yet</td></tr>";
    }
    return $html;
}

// Message printen met $type = css stijl
function printMessage($message, $type)
{
    unset($_SESSION['mess']);
    unset($_SESSION['err_mess']);
    if ($type === "success") {
        $message = "<span class='success'>" . $message . "</span>";
    } elseif ($type === "alert") {
        $message = "<span class='alert'>" . $message . "</span>";
    } else {
        $message = "<span>" . $message . "</span>";
    }

    $_SESSION['mess'] = $message;
}

// Session timeout control
function checkSession()
{

    $now = time();
    $delta = $now - $_SESSION['cur_session_time'];
    $timeSpan = 30 * 60;
    // $timeSpan = 10; //debug mode
    if ($delta <= $timeSpan) {
        $_SESSION['cur_session_time'] = $now;
    } else {
        // unset maakt het leeg
        header('Location: index.php');
        session_unset();
        //destroy maakt leeg
        session_destroy();
        // voor de message
        session_start();
        printMessage("Session timeout, please log back in", "alert");
        exit();
    }
}

// Check of we raken of niet
function hitOrMis($usrShot, $ships)
{

    // Voor elk schip controleren
    for ($i = 0; $i < count($ships); $i++) {

        // elk shhip heeft als methodefunctie hitOrMis, waar we dan kunnen checken of deze true is
        if ($ships[$i]->hitOrMis($usrShot)) {

            // Game message wordt geprint in de linkse container onder de boten
            $_SESSION['gameMessage'][$i] = "Hit!";

            // We vragen hier de volledige array op en slaan ze op in een variabele
            $fullArr = $ships[$i]->getLocArrUntouched();

            // We willen weten waar precies de usrshot ligt in onze array van locatie
            $key = array_search($usrShot, $fullArr);

            // // Is ons schot de 1e?
            // if ($usrShot == $fullArr[0]) {
            //     $_SESSION['hits'][$i][$key] = "<";
            //     // is ze de laatste?
            // } elseif ($usrShot == $fullArr[count($fullArr) - 1]) {
            //     $_SESSION['hits'][$i][$key] = ">";
            // } else {
            //     $_SESSION['hits'][$i][$key] = "X";
            // }
        } else {
            // Gemist? Display dit dan in de rechter container
            $_SESSION['gameMessage'][$i] = "Missed!";
        }
        // Is onze variabele array, waar onze geraakte schoten uit verwijderd word, leeg? Dan displayed we 'destroyed'
        if (empty($ships[$i]->getLocArr())) {
            $_SESSION['gameMessage'][$i] =  "Destroyed!";
        }
    }
}


function generateShips($amount, $fieldLength)
{
    unset($_SESSION['curShips']);
    unset($_SESSION['shots']);
    unset($_SESSION['ammo']);
    $_SESSION['ammo'] = 0;

    // Nieuwe class asignen
    $board = new gameBoard($fieldLength, $amount);

    // De schepen aanmaken en in een sessie steken
    $_SESSION['curShips'] = $board->createShips();

    // De ammo gaan definiëren
    $_SESSION['ammo'] = $board->getAmmo();
}



function printCurShotMessage()
{
    // Voor elk schip op basis van uw difficulty
    for ($i = 0; $i < count($_SESSION['curShips']); $i++) {
        echo " <span class='ships-container__wrap ships-wrap'>";
        // Naam displayenÒ
        echo "<span class='ships-wrap__title'>{$_SESSION['curShips'][$i]->getName()}</span>";
        echo "<span class='ships-wrap__item'>";

        // Is er geschoten? Zeggen of ze geraakt is of niet
        if (isset($_POST['shoot'])) {
            echo  $_SESSION['gameMessage'][$i];
        } else {
            echo "&nbsp;";
        }
        echo "</span>";
        echo "</span>";
    }
}


function printTable($rowLength)
{
    echo "<table>";

    // Rowlength is de variabele $diffTableRows in naval_battle -> Dit is de difficulty level -> beginner = 2, easy = 3, ...
    for ($i = 0; $i < $rowLength; $i++) {
        // Per rij een table row assignen
        echo "<tr>";
        // Elke rij heeft 10 kottekes
        for ($j = 0; $j < 10; $j++) {
            // Optellen van $i + $j, op een string niveau. Dit wordt dan het getal rechtsboven per table data
            $tdLoc = intval($i . $j) + 1;

            // Een id voor kweet niet welke reden
            echo "<td id='" .  $tdLoc . "'>";

            // Het nummer displayen (rechtsbovenaan)
            echo "<span class='td_number'>" . $tdLoc . "</span>";
            if ($_SESSION['gameState'] === true) {
                // Is er geschoten? 
                if (isset($_POST['shoot'])) {
                    // Kijk of onze huide locatie $tdLoc in onze scchoten array zit
                    if (in_array($tdLoc,  $_SESSION['shots'])) {
                        // Dan onze functie oproepen om te weten of je geraakt hebt of niet
                        echo printSymbol($tdLoc, $_SESSION['curShips']);
                    }
                }
            } else {
                echo "&nbsp;";
            }
            echo "</td>";
        }
        // Einde rij
        echo "</tr>";
    }

    echo "</table>";
}

function printSymbol($tdLoc, $ships)
{

    // ons schot controleren voor elk schip
    for ($i = 0; $i < count($ships); $i++) {
        $fullArr = $ships[$i]->getLocArrUntouched();
        // Zit ons shot in de één van onze locatie arrays?
        if (in_array($tdLoc, $fullArr)) {

            // return de volgende waarden
            if ($tdLoc == $fullArr[0]) {
                return "<";
            } elseif ($tdLoc == $fullArr[count($fullArr) - 1]) {
                return ">";
            } else {
                return "X";
            }
            // als het schot in geen enkel van de arrays zit
        } elseif ($i === count($ships) - 1) {
            return "O";
        }
    }
}

// Functie wordt aangemaakt omdat deze 2x gebruikt wordt, zo blijft de code toch 'een beetje'  overzichtelijker
function printDifficultyInput($difficultyStr)
{

    // Just some html shizzle
    $html = "<select name='difficulty' class='form__select' id='difficulty' autofocus>";
    $shipConjunct = "Ship";
    $selected = "selected";
    foreach ($difficultyStr as $key => $value) {
        $key += 1;

        // Woord vervoegen
        if ($key > 1) {
            $shipConjunct = "Ships";
            $selected = "";
        }

        // Zorgen dat de vorige difficulty selected is
        if ($key == $_SESSION['difficulty']) {
            $selected = "selected";
        }


        $html .= "<option value='$key' $selected>$value ($key $shipConjunct)</option>";
    }

    $html .=  "</select>";
    return $html;
}

// Some more htmlShizzles
function printGameForm($difficultyStr)
{
    echo "<legend>";
    if (!$_SESSION['tryAgain']) {
        if ($_SESSION['gameState'] === false) {
            echo "Do you dare?";
        } else {
            echo "Choose location";
        }
    } else {
        echo $_SESSION['gameEndMessage'];
    }

    echo "</legend>";
    echo "<form action='naval_battle.php' method='POST' class='content-item form'>";

    if (!$_SESSION['tryAgain']) {
        if ($_SESSION['gameState'] === false) {
            echo "Choose difficulty";
            echo printDifficultyInput($difficultyStr);
            echo "<input class='form__input' type='submit' name='startGame' value='Start Game!'>";
        } else {

            echo "<input class='form__input' name='usrShot' id='usr-shot' type='number' max='50' min='1' autofocus required>";
            echo "<input class='form__input' type='submit' name='shoot' value='Shoot!'>";
        }
    } else {

        echo printDifficultyInput($difficultyStr);
        echo '<input class="form__input" type="submit" name="tryAgain" value="Play Again?">';
    }

    echo "</form>";
}

// functie dij kijkt of alle schepen leeg zijn...
function checkIfAllDestroyed($ships)
{
    for ($i = 0; $i < count($ships); $i++) {
        if (empty($ships[$i]->getLocArr())) {
            // Zijn alle schepen leeg?
            if ($i == count($_SESSION['curShips']) - 1) {
                $_SESSION['gameEndMessage'] = "You won!";
                $_SESSION['won'] = 1;
                $_SESSION['gameState'] = true;
                $_SESSION['gameDone'] = true;

                $_SESSION['tryAgain'] = true;
                return true;
            }
        } else {
            return false;
        }
    }
}