<?php
session_start();
// TODO: Overlappen fixen!
class Ship
{
    protected $shipLength;
    protected $locStart;
    protected $locEnd;
    protected $locMiddle;
    protected $amountShots;
    protected $arrLoc;
    protected $name;
    protected $arrLocUntouched;
    protected $ammo;


    function __construct($fieldLength)
    {
        $this->createShip($fieldLength);
    }

    protected function createShip($fieldLength)
    {
        $this->calcLocMiddle($fieldLength);
        $this->calcLocStart();
        $this->calcLocEnd();
        $this->createLocArr();
    }

    protected function calcLocStart()
    {
        $this->locStart = $this->locMiddle - floor($this->shipLength / 2);
    }


    protected function calcLocEnd()
    {
        $this->locEnd = $this->locStart + $this->shipLength - 2;
    }

    public function calcLocMiddle($fieldLength)
    {
        // -2 verzorgt ervoor dat we niet over onze grid gaan
        $this->locMiddle = rand(4, $fieldLength - 2);
    }

    protected function createLocArr()
    {
        // 2 arrays opvullen, ene dynamisch, andere onaanpasbaar
        for ($i = $this->locStart; $i <= $this->locEnd; $i++) {
            $this->arrLoc[] = $i;
            $this->arrLocUntouched[] = $i;
        }
    }

    // deze functies spreken voor zich
    public function getLocStart()
    {
        return $this->locStart;
    }
    public function getLocEnd()
    {
        return $this->locEnd;
    }
    public function getLocArr()
    {
        return $this->arrLoc;
    }
    public function getLocArrUntouched()
    {
        return $this->arrLocUntouched;
    }
    public function hitOrMis($userShot)
    {

        // controleren of onze shot raak is, indien ja return true en verwijder deze uit onze dynamische arr
        if (in_array($userShot, $this->arrLoc)) {
            $key = array_search($userShot, $this->arrLoc);
            unset($this->arrLoc[$key]);
            return true;
        }


        return false;
    }

    public function ammo()
    {
        return $this->ammo = $this->shipLength + 3;
    }
}

// Alle schepen die de class Ship extenden
class Sub extends Ship
{

    protected function createShip($fieldLength)
    {
        $this->shipLength = 4;
        $this->calcLocMiddle($fieldLength);
        $this->calcLocStart();
        $this->calcLocEnd();
        $this->createLocArr();
        $this->ammo();
        $this->name = "Submarine";
    }

    public function getName()
    {
        return $this->name;
    }
}
// OF OP DEZE MANIER:
class Destroyer extends Ship
{

    protected function createShip($fieldLength)
    {
        $this->shipLength = 5;
        $this->calcLocMiddle($fieldLength);
        $this->calcLocStart();
        $this->calcLocEnd();
        $this->createLocArr();
        $this->ammo();
        $this->name = "Destroyer";
    }

    public function getName()
    {
        return $this->name;
    }
}

class Cruiser extends Ship
{
    protected function createShip($fieldLength)
    {
        $this->shipLength = 6;
        $this->calcLocMiddle($fieldLength);
        $this->calcLocStart();
        $this->calcLocEnd();
        $this->createLocArr();
        $this->ammo();
        $this->name = "Cruiser";
    }

    public function getName()
    {
        return $this->name;
    }
}

class BattleShip extends Ship
{
    protected function createShip($fieldLength)
    {
        $this->shipLength = 7;
        $this->calcLocMiddle($fieldLength);
        $this->calcLocStart();
        $this->calcLocEnd();
        $this->createLocArr();
        $this->ammo();
        $this->name = "Battleship";
    }

    public function getName()
    {
        return $this->name;
    }
}

class AircraftCarrier extends Ship
{
    protected function createShip($fieldLength)
    {
        $this->shipLength = 8;
        $this->calcLocMiddle($fieldLength);
        $this->calcLocStart();
        $this->calcLocEnd();
        $this->createLocArr();
        $this->ammo();
        $this->name = "Aircraft Carrier";
    }

    public function getName()
    {
        return $this->name;
    }
}

// class die onze board aanmaakt
class gameBoard
{
    protected $ships;
    protected $arr_startEnd;
    protected $length;
    protected $currentShips;
    protected $amountShips;
    protected $rdmNumbers;
    protected $ammo;
    protected $arr_startEndFull;


    function __construct($length, $amount)
    {
        // $length is momenteel de variabele in naval_battle.php $diffTableRows (2,3,4,5)
        $this->length = $length * 10;
        $this->amountShips = intval($amount);
    }

    // Functie die nooit dezelfde random nummer genereert
    protected function randomGenerator($min, $max, $amount)
    {
        $numbers = range($min, $max);
        shuffle($numbers);
        return array_slice($numbers, 0, $amount);
    }

    // Randomisatie ook nog kopieren…
    protected function declareShips($length)
    {
        $this->ships[0] = new Sub($length);
        $this->ships[1] = new Destroyer($length);
        $this->ships[2] = new Cruiser($length);
        $this->ships[3] = new BattleShip($length);
        $this->ships[4] = new AircraftCarrier($length);

        return $this->ships;
    }

    public function createShips()
    {

        $this->rdmNumbers = $this->randomGenerator(0, 4, $this->amountShips);
        $ships = $this->declareShips($this->length);


        for ($i = 0; $i < $this->amountShips; $i++) {
            // counter voor onze overlappingscontrole
            $counter = 0;

            // Dit kiest gewoon een random schip
            $this->currentShips[$i] = $ships[$this->rdmNumbers[$i]];
            $this->ammo += $this->currentShips[$i]->ammo();

            // De 1e keer is deze arr null en moet de controle niet gedaan worden…
            // dit is de controle om na te gaan of de schepen overlappen met elkaar, de 1e keer bij het aanmaken van een schip
            // hoeft de onderstaan de controle niet uitgevoerd te worden
            if ($this->arr_startEnd <> null) {


                while ($counter <= count($this->arr_startEnd)) {
                    $minVal = $this->arr_startEnd[$counter][0];
                    $maxVal = $this->arr_startEnd[$counter][1];
                    if ($minVal <> null || $maxVal <> null) {
                        // overlapt het nieuwe schip met de vorige waarden? zie volgende functie om te zien wat checkoverlap doet
                        if ($this->checkOverlap($this->currentShips[$i]->getLocArrUntouched(),  $minVal, $maxVal)) {

                            // Opnieuw nieuwe schepen aanmaken
                            $ships = $this->declareShips($this->length);
                            // Het nieuw schip overschrijven op de schip waar er overlapping gebeurd
                            $this->currentShips[$i] = $ships[$this->rdmNumbers[$i]];
                            // Counter resetten, anders controleert ze het nieuw schip niet met de vorige schepen
                            // Ik was deze vergeten resetten en zocht dus 2weken achter andere opties, terwijl het gwn maar 1 lijn code was :O
                            $counter = 0;
                        } else {
                            // Overlapt het nieuwe schip niet met de vorige in arr_startEnd -> dan gaan we naar het volgend schip
                            $counter++;
                        }
                    } else {
                        // Is er geen volgend schip? Counter++ doen zodat we uit de while loop gaan
                        $counter++;
                    }
                }
            }

            // De nieuwe begin-eindwaarden opslaan
            $this->arr_startEnd[$i][0] = $this->currentShips[$i]->getLocStart();
            $this->arr_startEnd[$i][1] = $this->currentShips[$i]->getLocEnd();
        }
        return $this->currentShips;
    }


    protected function checkOverlap($arr, $minVal, $maxVal)
    {
        // elk element afgaan van onze huidige schip en kijken of die tussen onze waarden vallen van onze vorige schepen (parameter)
        foreach ($arr as $el) {
            if (
                // de eerste is eigenlijk overbodig, but so be it
                $el == $minVal || $el == $maxVal ||
                $el >= $minVal && $el <= $maxVal
            ) {
                // is er een overlapping, return true, en dan wordt er nieuwe schepen gegenereerd
                return true;
            }
        }

        // werkt ook en is korter
        // if (in_array($minVal, $arr) || in_array($maxVal, $arr)) {
        //     return true;
        // }

        // geen overlappingen
        return false;
    }


    public function getShips()
    {
        return $this->currentShips;
    }

    public function getAmmo()
    {
        return $this->ammo;
    }

    public function getArrStartEnd()
    {
        return $this->arr_startEnd;
    }
}